package multipath;

import java.util.*;
import multipath.*;

public class Node {

  public int nodeNum;//node id
  public Node fatherNode;//father node
  public boolean isServer;//is server or not

  public Node() {
  }

  public Node(int nodeNump) {
    nodeNum=nodeNump;
    isServer=false;
  }

  //rewrite equal function
  public boolean isEqual(Node oNode){
    if(nodeNum==oNode.nodeNum)
      return true;
    else
      return false;
  }

  //calc the fatherNode for all servers by searching the path
  public static void calcFatherNode(){
    for(int nid=1;nid<=Multipath.maxNode;nid++){
      for(int pid=1;pid<=Multipath.maxPath;pid++){
        if(((Node)Multipath.nodes[nid]).isEqual(Multipath.pathes[pid].startNode)
             &&(!Multipath.pathes[pid].startNode.isServer))//node is not server
          {
            Multipath.nodes[nid].fatherNode=Multipath.pathes[pid].endNode;
          }
      }
    }
  }

}