//interface for Genetic Algorithm
//parameter controlling center
package multipath;

import java.util.*;
import java.text.*;

public interface GeneticAlgorithm {

  //parameters
  public static int populationSize=10;
  public static int stringSize=11;//max of string size
  public static double matingProb=0.7;
  public static double mutationProb=0.2;
  public static int numberGenerations=20;
  public static int tournament=10;

  public Vector generation=new Vector(1,1);

  public void run();
  public void generateInitialGeneration();
  public void updateBestSolution();
  public void generateNextGeneration();
}